

export class MapNew {
    private _arr:{key: cc.Component | cc.Node, value:(evt)=> void}[] = []
    ctor(){ 
        this._arr = []
    }
    set(key, value){
        let isHas = this.has(key)
        if (isHas){
            let item = this.get(key)
            item.value = value
            return;
        }
        this._arr.push({key: key, value: value})
    }

    get(key):any{
        for(let i = 0; i < this._arr.length; i++){
            let item = this._arr[i]
            if (item.key == key){
                return item
            }
        }
        return null
    }

    has(key):boolean{
        for(let i = 0; i < this._arr.length; i++){
            let item = this._arr[i]
            if (item.key == key){
                return true
            }
        }
        return false
    }

    delete(key){
        let index = -1
        for(let i = 0; i < this._arr.length; i++){
            let item = this._arr[i]
            if (item.key == key){
                index = i;
                break;
            }
        }
        if (index != -1){
            this._arr.splice(index, 1)
        }
    }
}

export class TouchEventUtils {
    private static touchEnableds: MapNew  = new MapNew();
    /** 禁止穿透 */
    static disableThrough(object: cc.Component | cc.Node, value: boolean) {
        let touchStart;
        if (!this.touchEnableds.has(object)) {
            touchStart = (evt) => {
                evt.stopPropagation();
            };
            this.touchEnableds.set(object, touchStart);
        } else {
            touchStart = this.touchEnableds.get(object);
        }
        let node = (object instanceof cc.Component) ? object.node : object;
        if (value) {
            node.off(cc.Node.EventType.TOUCH_START, touchStart, this);
            node.on(cc.Node.EventType.TOUCH_START, touchStart, this);
        } else {
            node.off(cc.Node.EventType.TOUCH_START, touchStart, this);
            this.touchEnableds.delete(object);
        }
    }

    /** 移除touchEnabled设置的事件 */
    static removeThroughEvent(object: cc.Component | cc.Node): void {
        let touchStart = this.touchEnableds.get(object);
        let node = (object instanceof cc.Component) ? object.node : object;
        node.off(cc.Node.EventType.TOUCH_START, touchStart, this);
        this.touchEnableds.delete(object);
    }
}