(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/DragComponent.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, '5fccdxq1nhPiIi0bosaXRCU', 'DragComponent', __filename);
// Script/DragComponent.ts

"use strict";
/*
 * @Author: house
 * @Date: 2019-07-27 14:26:07
 * @Last Modified by: house
 * @Last Modified time: 2019-08-10 18:19:56
 * 可拖拽组件
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var DragComponent = /** @class */ (function (_super) {
    __extends(DragComponent, _super);
    function DragComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * 拖拽目标对象数组
         */
        _this.targetNodeList = [];
        // 拖拽结果
        _this.eventNode = null;
        // 150毫秒发送一次拖拽事件
        _this._durTime = 150;
        _this._timeStamp = new Date().getTime();
        _this.isMoved = false;
        _this._zIndex = 0;
        return _this;
        // update (dt) {}
    }
    // onLoad () {}
    DragComponent.prototype.start = function () {
        this._timeStamp = new Date().getTime();
        this._pos = this.node.position;
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchStart, this);
        this.node.on(cc.Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
        this.node.on(cc.Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.node.on(cc.Node.EventType.TOUCH_CANCEL, this.onTouchEnd, this);
        this._zIndex = this.node.zIndex;
        // this.node.on(DragEvent.Drag_Success, this.onDragSuccessHandler, this);
    };
    // 重置坐标
    DragComponent.prototype.refreshPos = function () {
        this.node.zIndex = this._zIndex;
        this._pos = this.node.position;
    };
    DragComponent.prototype.onTouchStart = function () {
        this.touchStartHandler();
    };
    // 开始
    // @syncExe
    DragComponent.prototype.touchStartHandler = function () {
        this._isDragSuccess = false;
        this._timeStamp = new Date().getTime();
        // this.node.runAction(cc.sequence(cc.scaleTo(0.12, 0.9),cc.scaleTo(0.12, 1))); 
        this.node.zIndex = 100;
        this.isMoved = false;
        // this.eventEmit(DragEvent.Drag_Start);
    };
    // 移动
    DragComponent.prototype.onTouchMove = function (event) {
        if (this._isDragSuccess)
            return;
        var delta = event.getDelta();
        if (!this.isMoved && (Math.abs(delta.x) > 1.5 || Math.abs(delta.y) > 1.5)) {
            this.isMoved = true;
            this.onDragMoveHandler();
        }
        this.node.x += delta.x;
        this.node.y += delta.y;
        if (new Date().getTime() - this._timeStamp > this._durTime) {
            this._timeStamp = new Date().getTime();
            this.touchMoveHandler();
        }
        // this.eventEmit( DragEvent.Drag_Move, this.node.name );
    };
    DragComponent.prototype.onDragMoveHandler = function () {
        // this.eventEmit(DragEvent.Drag_Move);
    };
    DragComponent.prototype.touchMoveHandler = function () {
        // this.sendRpc(ComponentBase.synStatusSignNo, {
        //     nodeName:this.node.name,
        //     property:{
        //         position:this.node.position,
        //         zIndex:this.node.zIndex
        //     }
        // });
    };
    // 结束
    DragComponent.prototype.onTouchEnd = function () {
        var node = this.node;
        node.zIndex = this._zIndex;
        var isDragSuccess = false;
        var targetNodeName = '';
        // 碰撞检测
        for (var _i = 0, _a = this.targetNodeList; _i < _a.length; _i++) {
            var targetNode = _a[_i];
            if (targetNode && targetNode.active) {
                var gapWidth = Math.abs(targetNode.x - node.x);
                var gapHeight = Math.abs(targetNode.y - node.y);
                if (gapWidth < node.width * 0.5 && gapHeight < node.height * 0.5) {
                    isDragSuccess = true;
                    targetNodeName = targetNode.name;
                    break;
                }
            }
        }
        this.touchEndHandler(isDragSuccess, targetNodeName);
    };
    // @syncExe
    DragComponent.prototype.touchEndHandler = function (isDragSuccess, targetNodeName) {
        this._isDragSuccess = isDragSuccess;
        if (this._isDragSuccess) {
            // this.eventEmit(DragEvent.Drag_Success,targetNodeName);
            // for (const targetNode of this.targetNodeList) {
            //     if (targetNode.name === targetNodeName) {
            //         targetNode.emit(DragEvent.Drag_Copy,this._pos ,this.node.getComponent(cc.Sprite).spriteFrame,this.targetNodeList,this.node.name);
            //         break;
            //     }
            // }
        }
        if (!this._isDragSuccess && this.targetNodeList.length > 0) {
            this.backToOriginalPos();
        }
        else {
            // this.node.runAction(cc.scaleTo(0.12, 1));
        }
        // this.eventEmit(DragEvent.Drag_End,this._isDragSuccess);
        // if (!this.isMoved) {
        //     this.eventEmit(DragEvent.Touch);
        // }
        this.isMoved = false;
    };
    DragComponent.prototype.backToOriginalPos = function () {
        this.node.stopAllActions();
        this.node.zIndex = this._zIndex;
        var moveAct = cc.moveTo(0.28, this._pos.x, this._pos.y).easing(cc.easeSineOut());
        // this.node.runAction(cc.spawn(moveAct, cc.scaleTo(0.28,1)));
    };
    DragComponent.prototype.getInitPos = function () {
        return this._pos;
    };
    DragComponent.prototype.eventEmit = function (eventName, param) {
        // 抛出事，拖拽到目标
        if (this.eventNode) {
            this.eventNode.emit(eventName, this.node.name, param);
        }
        else {
            this.node.emit(eventName, this.node.name, param);
        }
    };
    __decorate([
        property({
            type: cc.Node,
            tooltip: '拖拽目标对象数组'
        })
    ], DragComponent.prototype, "targetNodeList", void 0);
    __decorate([
        property({
            type: cc.Node,
            tooltip: '事件响应对象'
        })
    ], DragComponent.prototype, "eventNode", void 0);
    DragComponent = __decorate([
        ccclass
    ], DragComponent);
    return DragComponent;
}(cc.Component));
exports.default = DragComponent;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=DragComponent.js.map
        